#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

typedef struct {
	HANDLE hFBase;//t@C
	HANDLE hFSub;//TuXg[ɒǉt@C
} ERO;

int OpenX(ERO *pero, char *base, char *sub)
{
	char subname[500];//t@C+TuXg[
	char nam[500], ext[500];
	
	_splitpath(sub, NULL, NULL, nam, ext);
	sprintf(subname, "%s:%s%s", base, nam, ext);
	
	pero->hFBase = CreateFile(subname, GENERIC_READ | GENERIC_WRITE, 
			FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (pero->hFBase == INVALID_HANDLE_VALUE) return FALSE;
	
	pero->hFSub = CreateFile(sub, GENERIC_READ | GENERIC_WRITE, 
			FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (pero->hFSub == INVALID_HANDLE_VALUE) {
		CloseHandle(pero->hFBase);
		return FALSE;
	}

	printf(
		"Ώۃt@C : %s\n"
		"Xg[   : %s%s\n"
		, base, nam, ext);
	
	return TRUE;
}

void CloseX(ERO *pero)
{
	CloseHandle(pero->hFBase);
	CloseHandle(pero->hFSub);
}

int WriteX(ERO *pero)
{
	DWORD r, w, p=0;
	char buf[10000];
	
	printf("TuXg[ɏ...\n");
	do {
		if (ReadFile (pero->hFSub , buf, 10000, &r, NULL) == FALSE) goto ERR;
		if (WriteFile(pero->hFBase, buf, r    , &w, NULL) == FALSE) goto ERR;
		p += r;
		printf("read : %8d \r", p);
	} while (r);
	printf("\nI\n");
	return TRUE;
ERR:
	printf("\nG[I\n");
	return FALSE;
}

int ReadX(ERO *pero, char *out)
{
	DWORD r, w, p=0;
	char buf[10000];
	HANDLE hFOut;
	
	hFOut = CreateFile(out, GENERIC_READ | GENERIC_WRITE, 
			FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFOut == INVALID_HANDLE_VALUE) return FALSE;
	printf("TuXg[ǂݍ...\n");
	printf("o̓t@C : %s\n", out);
	do {
		if (ReadFile (pero->hFBase, buf, 10000, &r, NULL) == FALSE) goto ERR;
		if (WriteFile(hFOut       , buf, r    , &w, NULL) == FALSE) goto ERR;
		p += r;
		printf("read : %8d \r", p);
	} while (r);
	printf("\nI\n");
	CloseHandle(hFOut);
	return TRUE;
	
ERR:
	printf("\nG[I\n");
	CloseHandle(hFOut);
	return FALSE;
}

int DeleteX(char *f, char *s)
{
	char ff[500];
	sprintf(ff, "%s:%s", f,s);
	printf("폜 : %s", ff);
	return DeleteFile(ff);
}


void usage(void)
{
	const char *msg = 
		"erox ver1.1\n"
		"TuXg[ɃG摜B\n"
		"\n"
		" erox w Ώۃt@C ރt@C\n"
		"ǂݍ erox r Ώۃt@C ǂݍރXg[ [o̓t@C]\n"
		"폜     erox d Ώۃt@C Xg[\n";
	
	printf("%s", msg);
	exit(0);
}



int main(int argc, char **argv)
{
	ERO e;
	
	if (argc < 4) usage();

	if (argv[1][0] == 'd') {
		DeleteX(argv[2], argv[3]);
		return 0;
	}
	
	if (OpenX(&e, argv[2], argv[3]) == FALSE) {
		printf("t@CI[vG[I\n");
		return 1;
		
	};
	if (argv[1][0] == 'r') {
		if (argc == 4) {
			ReadX(&e, argv[3]);
		} else {
			ReadX(&e, argv[4]);
		}
	} else if (argv[1][0] == 'w') {
		WriteX(&e);
	} 
	
	//nh
	CloseX(&e);
}